//“plusready”事件之后调用

//获取经纬度 成功回调，失败回调
function latitude(succ, error) {
	plus.geolocation.getCurrentPosition(
		function(res) {
			//成功回调
			var user_latitude = res.coords.latitude; //纬度
			var user_longitude = res.coords.longitude; //经度

			succ(res.coords)
		},
		//失败
		function(e) {
			error(
				e
			);
		}
	);
}
//创建文件 文件名，文件内容数据，成功回调，失败回调
function write(name, data, success, error) {
	plus.io.requestFileSystem(plus.io.PUBLIC_DOCUMENTS, function(fs) {
		fs.root.getFile(name + '.json', {
			create: true
		}, function(fileEntry) {
			fileEntry.file(function(file) {
				var fileWrite = new plus.io.FileWriter;
				fileEntry.createWriter(function(fileWrite) {
					fileWrite.write(data);
					fileWrite.onwrite = function(e) {
						success(e)
					}
				})
			});
		}, function(e) {
			error(e)
		});
	});
};

//读文件 文件名， 成功回调，失败回调
function reader(name, success, error) {
	plus.io.requestFileSystem(plus.io.PUBLIC_DOCUMENTS, function(fs) {
		fs.root.getFile(name + '.json', {
				create: true
			}, function(fileEntry) {
				fileEntry.file(function(file) {
					var fileReader = new plus.io.FileReader();
					fileReader.readAsText(file, 'utf-8');
					fileReader.onloadend = function(evt) {
						success(evt)
					}

				});
			},
			function(e) {
				error(e)
			}
		);
	});
}
//网络变换 WIFI回调 4g回调 ，无网络回调
function netChange(ntWifi, nt4g, ntNo) {
	document.addEventListener("netchange", onNetChange, false);

	function onNetChange() {
		//获取当前网络类型
		var nt = plus.networkinfo.getCurrentType();
		switch (nt) {
			case plus.networkinfo.CONNECTION_ETHERNET:
			case plus.networkinfo.CONNECTION_WIFI:
				ntWifi();
				break;
			case plus.networkinfo.CONNECTION_CELL2G:
			case plus.networkinfo.CONNECTION_CELL3G:
			case plus.networkinfo.CONNECTION_CELL4G:
				nt4g();
				break;
			default:
				ntNo();
				break;
		}
	}
}

//往指定文件夹创建文件 文件夹名 文件名 文件内容 成功回调，失败回调
function writeFile(path, name, data, success, error) {
	plus.io.requestFileSystem(plus.io.PUBLIC_DOCUMENTS, function(fs) {
		fs.root.getDirectory(path, {
			create: true,
			exclusive: false
		}, function(dir) {
			dir.getFile(name + ".josn", {
				create: true
			}, function(w) {
				w.createWriter(function(write) {
					write.seek(0);
					write.write(data);
					write.onwrite = function(e) {
						success(e)
					}
				});

			}, function(e) {
				error(e)
			});
		}, function(e) {
			error(e)
		});
	}, function(e) {
		error(e)
	})
}


//读取指定文件夹内容 文件夹名 文件名 成功回调，失败回调
//"storage/emulated/0/Android/data/io.dcloud.HBuilder/.HBuilder/documents/"
function readerFile(path, name, success, error) {
	plus.io.requestFileSystem(plus.io.PUBLIC_DOCUMENTS, function(fs) {
		fs.root.getDirectory(path, {
			create: true,
			exclusive: false
		}, function(dir) {
			dir.getFile(name + ".josn", {
				create: true
			}, function(file) {
				var fileReader = new plus.io.FileReader();
				fileReader.readAsText(file, 'utf-8');
				fileReader.onloadend = function(evt) {
					success(evt)
				}

			}, function(e) {
				error(e)
			});
		}, function(e) {
			error(e)
		});
	}, function(e) {
		error(e)
	});
}
//下载文件 下载链接 保存位置 成功回调 失败回调 文件存在回调
//"storage/emulated/0/Android/data/io.dcloud.HBuilder/.HBuilder/downloads/"
	function fileDownload(downUrl, savePath, success, error,presence) {
		//处理链接后问号
		var allUrl = downUrl.split("?")[0]
		//获取文件名称
		var filename = allUrl.substring(
			allUrl.lastIndexOf("/") + 1,
			allUrl.length
		);
		//修改为本地路径
		var relativePath = "_downloads/" + savePath + filename;
		//检查文件是否已存在
		plus.io.resolveLocalFileSystemURL(
			relativePath,
			function(entry) {
				console.log(savePath + "文件存在=" + relativePath);
				//如果文件存在
				function callback(res) {
					presence(res)
				}
				setUrlFromLocal(relativePath, callback)

			},
			function(e) {
				console.log()
				console.log(savePath + "文件不存在,联网下载=" + relativePath);
				//如果文件不存在
				downloadLocal(relativePath, savePath, success)
			}
		);

		function downloadLocal(relativePath, savePath, success) {

			var dtask = plus.downloader.createDownload(
				allUrl, {
					method: "GET",
					filename: "_downloads/" + savePath
				},
				function(d, status) {
					if (status == 200) {
						//下载成功
						console.log("下载成功=" + relativePath);
						//d.filename  
						setUrlFromLocal(d.filename, callback)

						function callback(res) {
							success(res)
						}
					} else {
						//下载失败,需删除 本地临时文件,否则下次进来时会检查到文件已存在
						console.log("下载失败=" + status + "==" + relativePath);
						//dtask.abort();//文档描述:取消下载,删除临时文件(但经测试临时文件没有删除,故使用delFile()方法删除);
						error()
						if (relativePath != null) {
							delFile(relativePath);
						}
					}
				}
			);
			dtask.start();
		}
		//本地相对路径("_downloads/logo.jpg")转成SD卡绝对路径("/storage/emulated/0/Android/data/io.dcloud.HBuilder/.HBuilder/downloads/logo.jpg");
		function setUrlFromLocal(relativePath, callback) {
			var sd_path = plus.io.convertLocalFileSystemURL(relativePath);
			callback(sd_path)
		}

		function delFile(relativePath) {
			plus.io.resolveLocalFileSystemURL(relativePath, function(entry) {
				entry.remove(
					function(entry) {
						console.log("文件删除成功==" + relativePath);
					},
					function(e) {
						console.log("文件删除失败=" + relativePath);
					}
				);
			});
		}
	}
	//获取设备唯一id
	function getUuid(success){
		success(plus.device.uuid )
	}
	//上传文件
		function createUpload(url,path) {
		var task = plus.uploader.createUpload( url, 
			{ method:"POST",blocksize:204800,priority:100 },
			function ( t, status ) {
				// 上传完成
				if ( status == 200 ) { 
					alert( "Upload success: " + t.url );
				} else {
					alert( "Upload failed: " + status );
				}
			}
		);
		task.addFile( path, {key:"testdoc"} ); //文件
		// task.addData( "string_key", "string_value" );
		//task.addEventListener( "statechanged", onStateChanged, false );
		task.start();
	}